#include <idc.idc>

static main(void)
{
  auto sectioninfo;
  auto impaddr;
  auto impend;
  auto reladdr;
  auto applyreloc;
  auto dataaddr;
  auto sectionbase;
  auto reltype;
  auto a;
  Enums();            // enumerations
  Structures();       // structure types
  MakeStructEx(0, -1, "OSModuleHeader");
  MakeNameEx(0, "Header", 1);
  sectioninfo = Dword(0x10);
  MakeStructEx(sectioninfo, -1, "OSSectionInfo");
  MakeArray(sectioninfo, Dword(0xC));
  MakeNameEx(sectioninfo, "Sections", 1);
  for (a = 0; a < Dword(0xC); a = a + 1)
  {
    sectionbase = Dword(sectioninfo + (a * 8)) & ~1;
	if (sectionbase != 0)
	{
	  Message("New section %x-%x\n", sectionbase, sectionbase + Dword(sectioninfo + 4 + (a * 8)));
      AddSeg(sectionbase, sectionbase + Dword(sectioninfo + 4 + (a * 8)), 0, 1, 0, 0);
	}
  }
  reladdr = Dword(0x24);
  MakeNameEx(reladdr, "Relocations", 1);
  impaddr = Dword(0x28);
  MakeNameEx(impaddr, "Imports", 1);
  impend = impaddr + Dword(0x2C);
  while (impaddr < impend)
  {
    MakeStructEx(impaddr, -1, "OSImportInfo");
	if (Dword(impaddr) == Dword(0))
	  applyreloc = 1;
	else
	  applyreloc = 0;
    reladdr = Dword(impaddr + 4);
    MakeStructEx(reladdr, -1, "OSRel");
    reltype = Byte(reladdr + 2);
    while (reltype != 0xCB)
    {
      dataaddr = dataaddr + Word(reladdr);
	  sectionbase = Dword(sectioninfo + (Byte(reladdr + 3) * 8)) & ~1;
	  if (applyreloc == 1)
	  {
	    if (reltype == 1)
	    {
          PatchDword(dataaddr, Dword(reladdr + 4) + sectionbase);
	      //Message("Patched bytes at %x\n", dataaddr);
	    }
        else if (reltype == 2)
	    {
          PatchDword(dataaddr, (Dword(dataaddr) & 0xFC000003) | ((Dword(reladdr + 4) + sectionbase) & 0x3FFFFFC));
	      //Message("Patched bytes at %x\n", dataaddr);
	    }
        else if (reltype == 3 | reltype == 4)
	    {
          PatchWord(dataaddr, Dword(reladdr + 4) + sectionbase);
	      //Message("Patched bytes at %x\n", dataaddr);
	    }
        else if (reltype == 5)
	    {
          PatchWord(dataaddr, (Dword(reladdr + 4) + sectionbase) >> 16);
	      //Message("Patched bytes at %x\n", dataaddr);
	    }
        else if (reltype == 6)
	    {
	      if (((Dword(reladdr + 4) + sectionbase) & 0x8000) == 0x8000)
	        a = 1;
          else
	        a = 0;
          PatchWord(dataaddr, ((Dword(reladdr + 4) + sectionbase) >> 16) + a);
	      //Message("Patched bytes at %x\n", dataaddr);
	    }
        else if (reltype == 0xA)
	    {
          PatchDword(dataaddr, (Dword(dataaddr) & 0xFC000003) | (((Dword(reladdr + 4) + sectionbase) - dataaddr) & 0x3FFFFFC));
	      //Message("Patched bytes at %x\n", dataaddr);
	    }
        else if (reltype == 0xCA)
	    {
          dataaddr = sectionbase;
	      //Message("dataaddr = %x\n", dataaddr);
	    }
        else if (reltype != 0 & reltype != 0xC9)
	      Warning("Unknown reltype %d at %x\n", reltype, reladdr);
      }
      reladdr = reladdr + 8;
	  MakeStructEx(reladdr, -1, "OSRel");
	  reltype = Byte(reladdr + 2);
    }
	impaddr = impaddr + 8;
  }
}

static Enums_0(id) {

	id = AddEnum(-1,"RelType",0x1100000);
	AddConstEx(id,"RelType_0",	0X0,	-1);
	AddConstEx(id,"RelType_1",	0X1,	-1);
	AddConstEx(id,"RelType_2",	0X2,	-1);
	AddConstEx(id,"RelType_3",	0X3,	-1);
	AddConstEx(id,"RelType_4",	0X4,	-1);
	AddConstEx(id,"RelType_5",	0X5,	-1);
	AddConstEx(id,"RelType_6",	0X6,	-1);
	AddConstEx(id,"RelType_A",	0XA,	-1);
	AddConstEx(id,"R_DOLPHIN_NOP",	0XC9,	-1);
	AddConstEx(id,"R_DOLPHIN_SECTION",	0XCA,	-1);
	AddConstEx(id,"R_DOLPHIN_END",	0XCB,	-1);
	return id;
}

//------------------------------------------------------------------------
// Information about enum types

static Enums(void) {
      auto id;
	id = Enums_0(id);
}

static Structures_0(id) {
      auto mid;

	id = AddStrucEx(-1,"OSModuleLink",0);
	id = AddStrucEx(-1,"OSModuleInfo",0);
	id = AddStrucEx(-1,"OSModuleHeader",0);
	id = AddStrucEx(-1,"OSSectionInfo",0);
	id = AddStrucEx(-1,"OSImportInfo",0);
	id = AddStrucEx(-1,"OSRel",0);
	
	id = GetStrucIdByName("OSModuleLink");
	mid = AddStrucMember(id,"next",	0X0,	0x20500400,	0X0,	4,	0XFFFFFFFF,	0X0,	0x000002);
	mid = AddStrucMember(id,"prev",	0X4,	0x20500400,	0X0,	4,	0XFFFFFFFF,	0X0,	0x000002);
	
	id = GetStrucIdByName("OSModuleInfo");
	mid = AddStrucMember(id,"id",	0X0,	0x20200400,	-1,	4);
	mid = AddStrucMember(id,"link",	0X4,	0x60000400,	GetStrucIdByName("OSModuleLink"),	8);
	mid = AddStrucMember(id,"numSections",	0XC,	0x20200400,	-1,	4);
	mid = AddStrucMember(id,"sectionInfoOffset",	0X10,	0x20500400,	0X0,	4,	0XFFFFFFFF,	0X0,	0x000002);
	mid = AddStrucMember(id,"nameOffset",	0X14,	0x20500400,	0X0,	4,	0XFFFFFFFF,	0X0,	0x000002);
	mid = AddStrucMember(id,"nameSize",	0X18,	0x20200400,	-1,	4);
	mid = AddStrucMember(id,"version",	0X1C,	0x20200400,	-1,	4);
	
	id = GetStrucIdByName("OSModuleHeader");
	mid = AddStrucMember(id,"info",	0X0,	0x60000400,	GetStrucIdByName("OSModuleInfo"),	32);
	mid = AddStrucMember(id,"bssSize",	0X20,	0x20200400,	-1,	4);
	mid = AddStrucMember(id,"relOffset",	0X24,	0x20500400,	0X0,	4,	0XFFFFFFFF,	0X0,	0x000002);
	mid = AddStrucMember(id,"impOffset",	0X28,	0x20500400,	0X0,	4,	0XFFFFFFFF,	0X0,	0x000002);
	mid = AddStrucMember(id,"impSize",	0X2C,	0x20100400,	-1,	4);
	mid = AddStrucMember(id,"prologSection",	0X30,	0x000400,	-1,	1);
	mid = AddStrucMember(id,"epilogSection",	0X31,	0x000400,	-1,	1);
	mid = AddStrucMember(id,"unresolvedSection",	0X32,	0x000400,	-1,	1);
	mid = AddStrucMember(id,"padding0",	0X33,	0x000400,	-1,	1);
	mid = AddStrucMember(id,"prolog",	0X34,	0x20500400,	0X0,	4,	0XFFFFFFFF,	0X0,	0x000002);
	mid = AddStrucMember(id,"epilog",	0X38,	0x20500400,	0X0,	4,	0XFFFFFFFF,	0X0,	0x000002);
	mid = AddStrucMember(id,"unresolved",	0X3C,	0x20500400,	0X0,	4,	0XFFFFFFFF,	0X0,	0x000002);
	mid = AddStrucMember(id,"align",	0X40,	0x20100400,	-1,	4);
	mid = AddStrucMember(id,"bssAlign",	0X44,	0x20100400,	-1,	4);
	
	id = GetStrucIdByName("OSSectionInfo");
	mid = AddStrucMember(id,"offset",	0X0,	0x20500400,	0X0,	4,	0XFFFFFFFF,	0X0,	0x000002);
	mid = AddStrucMember(id,"size",	0X4,	0x20100400,	-1,	4);
	
	id = GetStrucIdByName("OSImportInfo");
	mid = AddStrucMember(id,"id",	0X0,	0x20200400,	-1,	4);
	mid = AddStrucMember(id,"offset",	0X4,	0x20500400,	0X0,	4,	0XFFFFFFFF,	0X0,	0x000002);
	
	id = GetStrucIdByName("OSRel");
	mid = AddStrucMember(id,"offset",	0X0,	0x10000400,	-1,	2);
	mid = AddStrucMember(id,"type",	0X2,	0x800400,	GetEnum("RelType"),	1);
	mid = AddStrucMember(id,"section",	0X3,	0x000400,	-1,	1);
	mid = AddStrucMember(id,"addend",	0X4,	0x20000400,	-1,	4);
	return id;
}

//------------------------------------------------------------------------
// Information about structure types

static Structures(void) {
      auto id;
	id = Structures_0(id);
}

// End of file.
